# Source code for azure.mgmt.consumption.operations.aggregated_cost_operations

    # coding=utf-8
    # --------------------------------------------------------------------------
    # Copyright (c) Microsoft Corporation. All rights reserved.
    # Licensed under the MIT License. See License.txt in the project root for
    # license information.
    #
    # Code generated by Microsoft (R) AutoRest Code Generator.
    # Changes may cause incorrect behavior and will be lost if the code is
    # regenerated.
    # --------------------------------------------------------------------------

    import uuid
    from msrest.pipeline import ClientRawResponse

    from .. import models

    class AggregatedCostOperations(object):
        """AggregatedCostOperations operations.

        :param client: Client for service requests.
        :param config: Configuration of service client.
        :param serializer: An object model serializer.
        :param deserializer: An object model deserializer.
        :ivar api_version: Version of the API to be used with the client request. The current version is 2019-04-01-preview. Constant value: "2019-04-01-preview".
        """

        models = models

        def __init__(self, client, config, serializer, deserializer):

            self._client = client
            self._serialize = serializer
            self._deserialize = deserializer
            self.api_version = "2019-04-01-preview"

            self.config = config

        def get_by_management_group(
                self, management_group_id, filter=None, custom_headers=None, raw=False, **operation_config):
            """Provides the aggregate cost of a management group and all child
            management groups by current billing period.

            :param management_group_id: Azure Management Group ID.
            :type management_group_id: str
            :param filter: May be used to filter aggregated cost by
             properties/usageStart (Utc time), properties/usageEnd (Utc time). The
             filter supports 'eq', 'lt', 'gt', 'le', 'ge', and 'and'. It does not
             currently support 'ne', 'or', or 'not'. Tag filter is a key value pair
             string where key and value is separated by a colon (:).
            :type filter: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: ManagementGroupAggregatedCostResult or ClientRawResponse if
             raw=true
            :rtype:
             ~azure.mgmt.consumption.models.ManagementGroupAggregatedCostResult or
             ~msrest.pipeline.ClientRawResponse
            :raises:
             :class:`ErrorResponseException<azure.mgmt.consumption.models.ErrorResponseException>`
            """
            # Construct URL
            url = self.get_by_management_group.metadata['url']
            path_format_arguments = {
                'managementGroupId': self._serialize.url("management_group_id", management_group_id, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')
            if filter is not None:
                query_parameters['$filter'] = self._serialize.query("filter", filter, 'str')

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct and send request
            request = self._client.get(url, query_parameters, header_parameters)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                raise models.ErrorResponseException(self._deserialize, response)

            deserialized = None

            if response.status_code == 200:
                deserialized = self._deserialize('ManagementGroupAggregatedCostResult', response)

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                return client_raw_response

            return deserialized
        get_by_management_group.metadata = {'url': '/providers/Microsoft.Management/managementGroups/{managementGroupId}/providers/Microsoft.Consumption/aggregatedcost'}

        def get_for_billing_period_by_management_group(
                self, management_group_id, billing_period_name, custom_headers=None, raw=False, **operation_config):
            """Provides the aggregate cost of a management group and all child
            management groups by specified billing period.

            :param management_group_id: Azure Management Group ID.
            :type management_group_id: str
            :param billing_period_name: Billing Period Name.
            :type billing_period_name: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: ManagementGroupAggregatedCostResult or ClientRawResponse if
             raw=true
            :rtype:
             ~azure.mgmt.consumption.models.ManagementGroupAggregatedCostResult or
             ~msrest.pipeline.ClientRawResponse
            :raises:
             :class:`ErrorResponseException<azure.mgmt.consumption.models.ErrorResponseException>`
            """
            # Construct URL
            url = self.get_for_billing_period_by_management_group.metadata['url']
            path_format_arguments = {
                'managementGroupId': self._serialize.url("management_group_id", management_group_id, 'str'),
                'billingPeriodName': self._serialize.url("billing_period_name", billing_period_name, 'str')
            }
            url = self._client.format_url(url, **path_format_arguments)

            # Construct parameters
            query_parameters = {}
            query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

            # Construct headers
            header_parameters = {}
            header_parameters['Accept'] = 'application/json'
            if self.config.generate_client_request_id:
                header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
            if custom_headers:
                header_parameters.update(custom_headers)
            if self.config.accept_language is not None:
                header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

            # Construct and send request
            request = self._client.get(url, query_parameters, header_parameters)
            response = self._client.send(request, stream=False, **operation_config)

            if response.status_code not in [200]:
                raise models.ErrorResponseException(self._deserialize, response)

            deserialized = None

            if response.status_code == 200:
                deserialized = self._deserialize('ManagementGroupAggregatedCostResult', response)

            if raw:
                client_raw_response = ClientRawResponse(deserialized, response)
                return client_raw_response

            return deserialized
        get_for_billing_period_by_management_group.metadata = {'url': '/providers/Microsoft.Management/managementGroups/{managementGroupId}/providers/Microsoft.Billing/billingPeriods/{billingPeriodName}/Microsoft.Consumption/aggregatedcost'}